<?php

class Pricewars extends Module
{
    private $_html = '';
    private $_postErrors = array();

    function __construct()
    {
        $this->name = 'pricewars';
        $this->tab = 'Tools';
        $this->version = 0.1;

        parent::__construct();

        /* The parent construct is required for translations */
		$this->page = basename(__FILE__, '.php');
        $this->displayName = $this->l('Price wars!');
        $this->description = $this->l('Generuje xml z ofertą sklepu dla Ceneo, Nokaut, Skąpiec, Radar i okazje.info');
    }

	public function install()
	{
		if (!parent::install() OR !Configuration::updateValue('PRICEWARS_SKAPIEC_SHOP_ID', ''))
			return false;

		return true;
	}

	public function uninstall()
	{
		if (!Configuration::deleteByName('PRICEWARS_SKAPIEC_SHOP_ID') OR !parent::uninstall())
			return false;
		return true;
	}

	function getContent()
    {	
		
		$this->_postValidateProcess();

        $this->_html .= '<h2>Price wars!</h2>';
		$this->_displaySettingsForm();
		$this->_html .= '<br/><fieldset class="width4">
			<legend><img src="../img/admin/warning.gif" />Informacje</legend>
			Przy nawiązywaniu współpracy z porównywarkami cen podaj następujące linki jako lokoalizacje plików xml zawierających ofertę sklepu:<br /><br />
			<ul><li><b>Ceneo:</b> '.' <code>http://'.$_SERVER['HTTP_HOST'].__PS_BASE_URI__.'modules/'.$this->name.'/offer.php?service=ceneo</code></li>
			<li><b>Skąpiec:</b> '.' <code>http://'.$_SERVER['HTTP_HOST'].__PS_BASE_URI__.'modules/'.$this->name.'/offer.php?service=skapiec</code></li>
			<li><b>Nokaut:</b> '.' <code>http://'.$_SERVER['HTTP_HOST'].__PS_BASE_URI__.'modules/'.$this->name.'/offer.php?service=nokaut</code></li>
			<li><b>Radar:</b> '.' <code>http://'.$_SERVER['HTTP_HOST'].__PS_BASE_URI__.'modules/'.$this->name.'/offer.php?service=radar</code></li>
			<li><b>okazje.info.pl:</b> '.' <code>http://'.$_SERVER['HTTP_HOST'].__PS_BASE_URI__.'modules/'.$this->name.'/offer.php?service=okazje</code></li>
			</fieldset>';

        return $this->_html;
    }


	private function _displaySettingsForm()
	{
		$skapiecShopId = Configuration::get('PRICEWARS_SKAPIEC_SHOP_ID');
		if (sizeof($this->_postErrors))
			$this->_displayErrors();
		$this->_html .= '
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
		<fieldset class="width4">
			<legend><img src="../img/admin/contact.gif" />'.$this->l('Ustawienia').'</legend>
			<label>'.$this->l('Identyfikator Twojego sklepu w skapiec.pl').'</label>
			<div class="margin-form"><input type="text" size="10" name="skapiecShopId" value="'.$skapiecShopId.'" /></div>
		<br /><center><input type="submit" name="submitPricewars" value="'.$this->l('Zapisz zmiany').'" class="button" /></center>
		</fieldset>

		</form>';
	}


	private function _postValidateProcess(){
		if (isset($_POST['submitPricewars'])){
			if (empty($_POST['skapiecShopId']))
				$this->_postErrors[] = $this->l('Musisz podać id sklepu w skapiec.pl, o ile chcesz z niego korzystać.');
			else
				Configuration::updateValue('PRICEWARS_SKAPIEC_SHOP_ID', intval($_POST['skapiecShopId']));
		}
	}


	private function _displayErrors()
	{
		$nbErrors = sizeof($this->_postErrors);
		$this->_html .= '
		<div class="alert error">
			<h3>'.($nbErrors > 1 ? $this->l('Wystapily') : $this->l('Wystapil')).' '.$nbErrors.' '.($nbErrors > 1 ? $this->l('bledy') : $this->l('blad')).'</h3>
			<ol>';
		foreach ($this->_postErrors AS $error)
			$this->_html .= '<li>'.$error.'</li>';
		$this->_html .= '
			</ol>
		</div>';
	}

	private function _getCategoryTree(){

		$categories = Category::getCategories(Language::getIdByIso("pl"),false,false);
		$categoryArray = array ();

		foreach($categories as $category) {
			$categoryArray[$category['id_category']] = $category;
		}

		foreach ($categoryArray as $category) {
			$categoryParent = $categoryArray[$category['id_category']]['id_parent'];
			$categoryPath = $categoryArray[$category['id_category']]['name'];
			$counter = 0;
			while ($categoryParent) {
				$counter++;
				if ($counter > 100)
					break;
				if ($categoryParent != $categoryArray[$categoryParent]['id_parent']) {
					if ($categoryArray[$categoryParent]['id_category']!=1)
						$categoryPath = $categoryArray[$categoryParent]['name'] . "/" . $categoryPath;
					$categoryParent = $categoryArray[$categoryParent]['id_parent'];
				} else {
					$categoryParent = 0;
				}
			}
			$categoryArray[$category['id_category']]['path'] = $categoryPath;
		}
		return $categoryArray;
	}

	public function getXML(){

		if (isset($_GET['service'])){
			switch($_GET['service']){
			case "ceneo":  
				$xml = $this->_doCeneo();
				break;
			case "nokaut":  
				$xml = $this->_doNokaut();
				break;
			case "skapiec":  
				$xml = $this->_doSkapiec();
				break;
			case "radar":  
				$xml = $this->_doRadar();
				break;
			case "okazje":  
				$xml = $this->_doOkazje();
				break;
			default:
				echo "Nothing to do.";
				break;
			}
			echo $xml->saveXML();
		}else
			echo "Nothing to do.";
	}

	private function _doCeneo(){
		$link = new Link();
        $xml = new DOMDocument();
		
		$Products = Product::getProducts(Language::getIdByIso("pl"), 0, NULL, 'name', 'ASC');
		$Categories = $this->_getCategoryTree();

		if($Products&&$Categories){
			$xml->loadXML('<?xml version="1.0" encoding="UTF-8"?>
						   <!DOCTYPE pasaz:Envelope SYSTEM "loadOffers.dtd">
							<pasaz:Envelope xmlns:pasaz="http://schemas.xmlsoap.org/soap/envelope/">
							 <pasaz:Body>
							  <loadOffers xmlns="urn:ExportB2B">
							   <offers/>
							  </loadOffers>
							 </pasaz:Body>	
							</pasaz:Envelope>');

			$offers = $xml->getElementsByTagName('offers');
			$offers = $offers->item(0);

			foreach ($Products AS $Product){
				if ($Product['active']==1){


					$offer = $xml->createElement('offer');
					$offers->appendChild($offer);

					$id = $xml->createElement('id',$Product['id_product']);
					$offer->appendChild($id);
					
					$name = $xml->createElement('name',$Product['name']); 
					$offer->appendChild($name);

					$price = $xml->createElement('price',Product::getPriceStatic($Product['id_product'])); 
					$offer->appendChild($price);

					$url = $xml->createElement('url','http://'.$_SERVER['HTTP_HOST'].htmlspecialchars($link->getProductLink($Product['id_product'], $Product['link_rewrite'])));
					$offer->appendChild($url);

					$categoryId = $xml->createElement('categoryId',$Categories[$Product['id_category_default']]['path']);
					$offer->appendChild($categoryId);

					$description_cdata = $xml->createCDATASection(strip_tags(html_entity_decode($Product['description_short'],ENT_COMPAT,"UTF-8"),"<br><li><p><ul><tr>"));
					$description = $xml->createElement('description');
					$description->appendChild($description_cdata);
					$offer->appendChild($description);

					$image = Image::getCover($Product['id_product']);					
					if ($image['id_image'])
						$img_url = 'http://'.$_SERVER['HTTP_HOST'].__PS_BASE_URI__.'img/p/'.$image['id_product'].'-'.$image['id_image'].'-large.jpg';
					else
						$img_url = "";
					$image = $xml->createElement('image',$img_url);
					$offer->appendChild($image);
					
$attributes = $xml->createElement('attributes');
					$offer->appendChild($attributes);

                    $attribute = $xml->createElement('attribute');
					$attributes->appendChild($attribute);

                    $name = $xml->createElement('name',Producent);
					$attribute->appendChild($name);

                    $value = $xml->createElement('value',$Product['manufacturer_name']);
					$attribute->appendChild($value);



				}
			}
		}
		return $xml;
	}

	private function _doNokaut(){
		$link = new Link();
        $xml = new DOMDocument();
		
		$Products = Product::getProducts(Language::getIdByIso("pl"), 0, NULL, 'name', 'ASC');
		$Categories = $this->_getCategoryTree();

		if($Products&&$Categories){
			$xml->loadXML('<?xml version="1.0" encoding="UTF-8"?>
						   <!DOCTYPE nokaut SYSTEM "http://www.nokaut.pl/integracja/nokaut.dtd">
							<nokaut>
							   <offers/>
							</nokaut>');

			$offers = $xml->getElementsByTagName('offers');
			$offers = $offers->item(0);

			foreach ($Products AS $Product){
				if ($Product['active']==1){

					$offer = $xml->createElement('offer');
					$offers->appendChild($offer);

					$id = $xml->createElement('id',$Product['id_product']);
					$offer->appendChild($id);
					
					$name = $xml->createElement('name',$Product['name']); 
					$offer->appendChild($name);

					$description_cdata = $xml->createCDATASection(strip_tags(html_entity_decode($Product['description_short'],ENT_COMPAT,"UTF-8"),"<br><li><p><ul><tr>"));
					$description = $xml->createElement('description');
					$description->appendChild($description_cdata);
					$offer->appendChild($description);

					$url = $xml->createElement('url','http://'.$_SERVER['HTTP_HOST'].htmlspecialchars($link->getProductLink($Product['id_product'], $Product['link_rewrite'])));
					$offer->appendChild($url);

					$image = Image::getCover($Product['id_product']);					
					if ($image['id_image'])
						$img_url = 'http://'.$_SERVER['HTTP_HOST'].__PS_BASE_URI__.'img/p/'.$image['id_product'].'-'.$image['id_image'].'-large.jpg';
					else
						$img_url = "";
					$image = $xml->createElement('image',$img_url);
					$offer->appendChild($image);

					$price = $xml->createElement('price',Product::getPriceStatic($Product['id_product'])); 
					$offer->appendChild($price);

					$category = $xml->createElement('category',$Categories[$Product['id_category_default']]['path']);
					$offer->appendChild($category);

					$producer = $xml->createElement('producer',$Product['manufacturer_name']);
					$offer->appendChild($producer);
				}
			}
		}
		return $xml;
	}

	private function _doSkapiec(){
		$link = new Link();
        $xml = new DOMDocument();
		
		$Products = Product::getProducts(Language::getIdByIso("pl"), 0, NULL, 'name', 'ASC');
		$Categories = $this->_getCategoryTree();

		if($Products&&$Categories){
			$xml->loadXML('<?xml version="1.0" encoding="UTF-8"?>
							<xmldata>
							  <version>10</version>
							  <header/>		
							  <category/>
							  <data/> 
							</xmldata>');

			$header = $xml->getElementsByTagName('header');
			$header = $header->item(0);

			$name = $xml->createElement('name',Configuration::get('PS_SHOP_NAME'));
			$header->appendChild($name);

			$shopid = $xml->createElement('shopid',Configuration::get('PRICEWARS_SKAPIEC_SHOP_ID') ? Configuration::get('PRICEWARS_SKAPIEC_SHOP_ID') : "");
			$header->appendChild($shopid);

			$www = $xml->createElement('www','http://'.$_SERVER['HTTP_HOST'].__PS_BASE_URI__);
			$header->appendChild($www);

			$time = $xml->createElement('time',date('Y-m-d'));
			$header->appendChild($time);

			$category = $xml->getElementsByTagName('category');
			$category = $category->item(0);

			foreach($Categories as $catitem){
				$cat = $xml->createElement('catitem');
				$category->appendChild($cat);

				$catid = $xml->createElement('catid',$catitem['id_category']);
				$cat->appendChild($catid);

				$catname = $xml->createElement('catname',$Categories[$catitem['id_category']]['path']);   
				$cat->appendChild($catname);
			}

			$data = $xml->getElementsByTagName('data');
			$data = $data->item(0);

			foreach ($Products AS $Product){
				if ($Product['active']==1){

					$item = $xml->createElement('item');
					$data->appendChild($item);

					$compid = $xml->createElement('compid',$Product['id_product']);
					$item->appendChild($compid);

					$vendor = $xml->createElement('vendor',$Product['manufacturer_name']);
					$item->appendChild($vendor);

					$desc = $xml->createElement('desc',$Product['name']); 
					$item->appendChild($desc);

					$price = $xml->createElement('price',Product::getPriceStatic($Product['id_product'])); 
					$item->appendChild($price);

					$catid = $xml->createElement('catid',$Product['id_category_default']); 
					$item->appendChild($catid);

				}
			}
		}
		return $xml;
	}

	private function _doRadar(){
		$link = new Link();
        $xml = new DOMDocument();
		
		$Products = Product::getProducts(Language::getIdByIso("pl"), 0, NULL, 'name', 'ASC');
		$Categories = $this->_getCategoryTree();

		if($Products&&$Categories){
			$xml->loadXML('<?xml version="1.0" encoding="UTF-8"?>
						   <radar wersja="1.0">
							 <oferta/>
							</radar>');

			$oferta = $xml->getElementsByTagName('oferta');
			$oferta = $oferta->item(0);

			foreach ($Products AS $Product){
				if ($Product['active']==1){

					$produkt = $xml->createElement('produkt');
					$oferta->appendChild($produkt);

					$grupa1 = $xml->createElement('grupa1');
					$produkt->appendChild($grupa1);

					$nazwa = $xml->createElement('nazwa',$Product['name']); 
					$grupa1->appendChild($nazwa);

					$producent = $xml->createElement('producent',$Product['manufacturer_name']);
					$grupa1->appendChild($producent);

					$description_cdata = $xml->createCDATASection(strip_tags(html_entity_decode($Product['description_short'],ENT_COMPAT,"UTF-8")));
					$opis = $xml->createElement('opis');
					$opis->appendChild($description_cdata);
					$grupa1->appendChild($opis);

					$id = $xml->createElement('id',$Product['id_product']);
					$grupa1->appendChild($id);
					
					$url = $xml->createElement('url','http://'.$_SERVER['HTTP_HOST'].htmlspecialchars($link->getProductLink($Product['id_product'], $Product['link_rewrite'])));
					$grupa1->appendChild($url);

					$image = Image::getCover($Product['id_product']);					
					if ($image['id_image'])
						$img_url = 'http://'.$_SERVER['HTTP_HOST'].__PS_BASE_URI__.'img/p/'.$image['id_product'].'-'.$image['id_image'].'-large.jpg';
					else
						$img_url = "";
					$foto = $xml->createElement('foto',$img_url);
					$grupa1->appendChild($foto);

					$kategoria = $xml->createElement('kategoria',$Categories[$Product['id_category_default']]['path']);
					$grupa1->appendChild($kategoria);

					$cena = $xml->createElement('cena',Product::getPriceStatic($Product['id_product'])); 
					$grupa1->appendChild($cena);
				}
			}
		}
		return $xml;
	}

	private function _doOkazje(){
		$link = new Link();
        $xml = new DOMDocument();
		
		$Products = Product::getProducts(Language::getIdByIso("pl"), 0, NULL, 'name', 'ASC');
		$Categories = $this->_getCategoryTree();

		if($Products&&$Categories){
			$xml->loadXML('<?xml version="1.0" encoding="UTF-8" ?>
							<okazje>
								<offers/>
							</okazje>');

			$offers = $xml->getElementsByTagName('offers');
			$offers = $offers->item(0);

			foreach ($Products AS $Product){
				if ($Product['active']==1){

					$offer = $xml->createElement('offer');
					$offers->appendChild($offer);

					$id = $xml->createElement('id',$Product['id_product']);
					$offer->appendChild($id);
					
					$name = $xml->createElement('name',$Product['name']); 
					$offer->appendChild($name);

					$description_cdata = $xml->createCDATASection(strip_tags(html_entity_decode($Product['description_short'],ENT_COMPAT,"UTF-8"),"<br><li><p><ul><tr>"));
					$description = $xml->createElement('description');
					$description->appendChild($description_cdata);
					$offer->appendChild($description);

					$category = $xml->createElement('category',$Categories[$Product['id_category_default']]['path']);
					$offer->appendChild($category);

					$price = $xml->createElement('price',Product::getPriceStatic($Product['id_product'])); 
					$offer->appendChild($price);

					$url = $xml->createElement('url','http://'.$_SERVER['HTTP_HOST'].htmlspecialchars($link->getProductLink($Product['id_product'], $Product['link_rewrite'])));
					$offer->appendChild($url);

					$producer = $xml->createElement('producer',$Product['manufacturer_name']);
					$offer->appendChild($producer);

					$image = Image::getCover($Product['id_product']);					
					if ($image['id_image'])
						$img_url = 'http://'.$_SERVER['HTTP_HOST'].__PS_BASE_URI__.'img/p/'.$image['id_product'].'-'.$image['id_image'].'-large.jpg';
					else
						$img_url = "";
					$image = $xml->createElement('image',$img_url);
					$offer->appendChild($image);
				}
			}
		}
		return $xml;
	}

}

?>